Package org.apache.sysds.runtime.compress.colgroup

# Class ColGroupEmpty

java.lang.Object
org.apache.sysds.runtime.compress.colgroup.AColGroup
org.apache.sysds.runtime.compress.colgroup.AColGroupCompressed
org.apache.sysds.runtime.compress.colgroup.ColGroupEmpty

All Implemented Interfaces:
  `Serializable`, `AOffsetsGroup`, `IContainADictionary`, `IContainDefaultTuple`, `IMapToDataGroup`

public class ColGroupEmpty extends AColGroupCompressed implements IContainADictionary, IContainDefaultTuple, AOffsetsGroup, IMapToDataGroup

See Also:
  - Serialized Form

## Nested Class Summary

## Nested classes/interfaces inherited from class org.apache.sysds.runtime.compress.colgroup.AColGroup

`AColGroup.CompressionType`

## Constructor Summary

Constructors
Constructor
Description
`ColGroupEmpty(IColIndex colIndices)`
Constructs an Constant Colum Group, that contains only one tuple, with the given value.

## Method Summary

Modifier and Type
Method
Description
`AColGroup`
`append(AColGroup g)`
Append the other column group to this column group.
`AColGroup`
`appendNInternal(AColGroup[] g, int blen, int rlen)`
`AColGroup`
`binaryRowOpLeft(BinaryOperator op, double[] v, boolean isRowSafe)`
Perform a binary row operation.
`AColGroup`
`binaryRowOpRight(BinaryOperator op, double[] v, boolean isRowSafe)`
Perform a binary row operation.
`CmCovObject`
`centralMoment(CMOperator op, int nRows)`
Central Moment instruction executed on a column group.
`AColGroup`
`combineWithSameIndex(int nRow, int nCol, List<AColGroup> right)`
C bind the list of column groups with this column group.
`AColGroup`
`combineWithSameIndex(int nRow, int nCol, AColGroup right)`
C bind the given column group to this.
`void`
`computeColSums(double[] c, int nRows)`
Compute the column sum
`boolean`
`containsValue(double pattern)`
Detect if the column group contains a specific value.
`AColGroup`
`copyAndSet(IColIndex colIndexes)`
Copy the content of the column group with pointers to the previous content but with new column given Note this method does not verify if the colIndexes specified are valid and correct dimensions for the underlying column groups.
`static ColGroupEmpty`
`create(int nCol)`
`void`
`decompressToDenseBlock(DenseBlock target, int rl, int ru, int offR, int offC)`
Decompress into the DenseBlock.
`void`
`decompressToDenseBlockTransposed(DenseBlock db, int rl, int ru)`
Decompress a range of rows into a dense transposed block.
`void`
`decompressToSparseBlock(SparseBlock sb, int rl, int ru, int offR, int offC)`
Decompress into the SparseBlock.
`void`
`decompressToSparseBlockTransposed(SparseBlockMCSR sb, int nColOut)`
Decompress the column group to the sparse transposed block.
`org.apache.sysds.runtime.compress.colgroup.AColGroup.ColGroupType`
`getColGroupType()`
`CompressedSizeInfoColGroup`
`getCompressionInfo(int nRow)`
Get the compression info for this column group.
`ICLAScheme`
`getCompressionScheme()`
Get the compression scheme for this column group to enable compression of other data.
`AColGroup.CompressionType`
`getCompType()`
Obtain the compression type.
`double`
`getCost(ComputationCostEstimator e, int nRows)`
Get the computation cost associated with this column group.
`double[]`
`getDefaultTuple()`
`ADictionary`
`getDictionary()`
`IEncode`
`getEncoding()`
Get encoding of this column group.
`double`
`getIdx(int r, int colIdx)`
Get the value at a colGroup specific row/column index position.
`AMapToData`
`getMapToData()`
`final double`
`getMax()`
Short hand method for getting maximum value contained in this column group.
`final double`
`getMin()`
Short hand method for getting minimum value contained in this column group.
`long`
`getNumberNonZeros(int nRows)`
Get the number of nonZeros contained in this column group.
`int`
`getNumValues()`
Obtain number of distinct tuples in contained sets of values associated with this column group.
`AOffset`
`getOffsets()`
`double`
`getSparsity()`
Get an approximate sparsity of this column group
`boolean`
`isEmpty()`
Get if the group is only containing zero
`void`
`leftMultByAColGroup(AColGroup lhs, MatrixBlock c, int nRows)`
Left side matrix multiplication with a column group that is transposed.
`void`
`leftMultByMatrixNoPreAgg(MatrixBlock matrix, MatrixBlock result, int rl, int ru, int cl, int cu)`
Left multiply with this column group.
`static ColGroupEmpty`
`read(DataInput in)`
`AColGroup`
`recompress()`
Recompress this column group into a new column group.
`AColGroup`
`reduceCols()`
Perform row sum on the internal dictionaries, and return the same index structure.
`AColGroup`
`removeEmptyRows(boolean[] selectV, int rOut)`
Return a new column group containing only the selected rows in the given boolean vector.
`AColGroup`
`replace(double pattern, double replace)`
Make a copy of the column group values, and replace all values that match pattern with replacement value.
`AColGroup`
`rexpandCols(int max, boolean ignore, boolean cast, int nRows)`
Expand the column group to multiple columns.
`AColGroup`
`rightMultByMatrix(MatrixBlock right, IColIndex allCols, int k)`
Right matrix multiplication with this column group.
`boolean`
`sameIndexStructure(AColGroupCompressed that)`
`AColGroup`
`scalarOperation(ScalarOperator op)`
Perform the specified scalar operation directly on the compressed column group, without decompressing individual cells if possible.
`AColGroup`
`sliceRows(int rl, int ru)`
Slice range of rows out of the column group and return a new column group only containing the row segment.
`AColGroup`
`sort()`
Sort the values of the column group according to double comparison operations and return as another compressed group.
`AColGroup[]`
`splitReshape(int multiplier, int nRow, int nColOrg)`
This method returns a list of column groups that are naive splits of this column group as if it is reshaped.
`void`
`tsmmAColGroup(AColGroup other, MatrixBlock result)`
Matrix multiply with this other column group, but: 1.
`AColGroup`
`unaryOperation(UnaryOperator op)`
Perform unary operation on the column group and return a new column group

### Methods inherited from class org.apache.sysds.runtime.compress.colgroup.AColGroupCompressed

`getSum, preAggRows, sameIndexStructure, tsmm, unaryAggregateOperations, unaryAggregateOperations`

### Methods inherited from class org.apache.sysds.runtime.compress.colgroup.AColGroup

`addVector, appendN, clear, colSum, combine, decompressToDenseBlock, decompressToSparseBlock, estimateInMemorySize, get, getColIndices, getExactSizeOnDisk, getNumCols, morph, removeEmptyCols, rightDecompressingMult, rightMultByMatrix, selectionMultiply, shiftColIndices, sliceColumn, sliceColumns, sortColumnIndexes, splitReshapePushDown, toString`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### ColGroupEmpty

public ColGroupEmpty(IColIndex colIndices)
Constructs an Constant Colum Group, that contains only one tuple, with the given value.

Parameters:
  `colIndices` - The Colum indexes for the column group.

## Method Details

### create

public static ColGroupEmpty create(int nCol)

### getCompType

public AColGroup.CompressionType getCompType()
Description copied from class: `AColGroup`
Obtain the compression type.

Specified by:
  `getCompType` in class `AColGroup`
Returns:
  How the elements of the column group are compressed.

### getColGroupType

public org.apache.sysds.runtime.compress.colgroup.AColGroup.ColGroupType getColGroupType()

### decompressToDenseBlock

public void decompressToDenseBlock(DenseBlock target, int rl, int ru, int offR, int offC)
Description copied from class: `AColGroup`
Decompress into the DenseBlock. (no NNZ handling)

Specified by:
  `decompressToDenseBlock` in class `AColGroup`
Parameters:
  `target` - Target DenseBlock
  `rl` - Row to start decompression from
  `ru` - Row to end decompression at (not inclusive)
  `offR` - Row offset into the target to decompress
  `offC` - Column offset into the target to decompress

### decompressToSparseBlock

public void decompressToSparseBlock(SparseBlock sb, int rl, int ru, int offR, int offC)
Description copied from class: `AColGroup`
Decompress into the SparseBlock. (no NNZ handling) Note this method is allowing to calls to append since it is assumed that the sparse column indexes are sorted afterwards

Specified by:
  `decompressToSparseBlock` in class `AColGroup`
Parameters:
  `sb` - Target SparseBlock
  `rl` - Row to start decompression from
  `ru` - Row to end decompression at (not inclusive)
  `offR` - Row offset into the target to decompress
  `offC` - Column offset into the target to decompress

### decompressToDenseBlockTransposed

public void decompressToDenseBlockTransposed(DenseBlock db, int rl, int ru)
Description copied from class: `AColGroup`
Decompress a range of rows into a dense transposed block.

Specified by:
  `decompressToDenseBlockTransposed` in class `AColGroup`
Parameters:
  `db` - Dense target block
  `rl` - Row in this column group to start at.
  `ru` - Row in this column group to end at.

### decompressToSparseBlockTransposed

public void decompressToSparseBlockTransposed(SparseBlockMCSR sb, int nColOut)
Description copied from class: `AColGroup`
Decompress the column group to the sparse transposed block. Note that the column groups would only need to decompress into specific sub rows of the Sparse block

Specified by:
  `decompressToSparseBlockTransposed` in class `AColGroup`
Parameters:
  `sb` - Sparse target block
  `nColOut` - The number of columns in the sb.

### getIdx

public double getIdx(int r, int colIdx)
Description copied from class: `AColGroup`
Get the value at a colGroup specific row/column index position.

Specified by:
  `getIdx` in class `AColGroup`
Parameters:
  `r` - row
  `colIdx` - column index in the _colIndexes.
Returns:
  value at the row/column index position

### scalarOperation

public AColGroup scalarOperation(ScalarOperator op)
Description copied from class: `AColGroup`
Perform the specified scalar operation directly on the compressed column group, without decompressing individual cells if possible.

Specified by:
  `scalarOperation` in class `AColGroup`
Parameters:
  `op` - operation to perform
Returns:
  version of this column group with the operation applied

### unaryOperation

public AColGroup unaryOperation(UnaryOperator op)
Description copied from class: `AColGroup`
Perform unary operation on the column group and return a new column group

Specified by:
  `unaryOperation` in class `AColGroup`
Parameters:
  `op` - The operation to perform
Returns:
  The new column group

### binaryRowOpLeft

public AColGroup binaryRowOpLeft(BinaryOperator op, double[] v, boolean isRowSafe)
Description copied from class: `AColGroup`
Perform a binary row operation.

Specified by:
  `binaryRowOpLeft` in class `AColGroup`
Parameters:
  `op` - The operation to execute
  `v` - The vector of values to apply the values contained should be at least the length of the highest value in the column index
  `isRowSafe` - True if the binary op is applied to an entire zero row and all results are zero
Returns:
  A updated column group with the new values.

### binaryRowOpRight

public AColGroup binaryRowOpRight(BinaryOperator op, double[] v, boolean isRowSafe)
Description copied from class: `AColGroup`
Perform a binary row operation.

Specified by:
  `binaryRowOpRight` in class `AColGroup`
Parameters:
  `op` - The operation to execute
  `v` - The vector of values to apply the values contained should be at least the length of the highest value in the column index
  `isRowSafe` - True if the binary op is applied to an entire zero row and all results are zero
Returns:
  A updated column group with the new values.

### getNumValues

public int getNumValues()
Description copied from class: `AColGroup`
Obtain number of distinct tuples in contained sets of values associated with this column group. If the column group is uncompressed the number or rows is returned.

Specified by:
  `getNumValues` in class `AColGroup`
Returns:
  the number of distinct sets of values associated with the bitmaps in this column group

### leftMultByAColGroup

public void leftMultByAColGroup(AColGroup lhs, MatrixBlock c, int nRows)
Description copied from class: `AColGroup`
Left side matrix multiplication with a column group that is transposed.

Specified by:
  `leftMultByAColGroup` in class `AColGroup`
Parameters:
  `lhs` - The left hand side Column group to multiply with, the left hand side should be considered transposed. Also it should be guaranteed that this column group is not empty.
  `c` - The result matrix to insert the result of the multiplication into
  `nRows` - Number of rows in the lhs colGroup

### tsmmAColGroup

public void tsmmAColGroup(AColGroup other, MatrixBlock result)
Description copied from class: `AColGroup`
Matrix multiply with this other column group, but: 1. Only output upper triangle values. 2. Multiply both ways with "this" being on the left and on the right. It should be guaranteed that the input is not the same as the caller of the method. The second step is achievable by treating the initial multiplied matrix, and adding its values to the correct locations in the output.

Specified by:
  `tsmmAColGroup` in class `AColGroup`
Parameters:
  `other` - The other Column group to multiply with
  `result` - The result matrix to put the results into

### leftMultByMatrixNoPreAgg

public void leftMultByMatrixNoPreAgg(MatrixBlock matrix, MatrixBlock result, int rl, int ru, int cl, int cu)
Description copied from class: `AColGroup`
Left multiply with this column group.

Specified by:
  `leftMultByMatrixNoPreAgg` in class `AColGroup`
Parameters:
  `matrix` - The matrix to multiply with on the left
  `result` - The result to output the values into, always dense for the purpose of the column groups parallelizing
  `rl` - The row to begin the multiplication from on the lhs matrix
  `ru` - The row to end the multiplication at on the lhs matrix
  `cl` - The column to begin the multiplication from on the lhs matrix
  `cu` - The column to end the multiplication at on the lhs matrix

### containsValue

public boolean containsValue(double pattern)
Description copied from class: `AColGroup`
Detect if the column group contains a specific value.

Specified by:
  `containsValue` in class `AColGroup`
Parameters:
  `pattern` - The value to look for.
Returns:
  boolean saying true if the value is contained.

### getNumberNonZeros

public long getNumberNonZeros(int nRows)
Description copied from class: `AColGroup`
Get the number of nonZeros contained in this column group.

Specified by:
  `getNumberNonZeros` in class `AColGroup`
Parameters:
  `nRows` - The number of rows in the column group, this is used for groups that does not contain information about how many rows they have.
Returns:
  The nnz.

### rightMultByMatrix

public AColGroup rightMultByMatrix(MatrixBlock right, IColIndex allCols, int k)
Description copied from class: `AColGroup`
Right matrix multiplication with this column group. This method can return null, meaning that the output overlapping group would have been empty.

Specified by:
  `rightMultByMatrix` in class `AColGroup`
Parameters:
  `right` - The MatrixBlock on the right of this matrix multiplication
  `allCols` - A pre-materialized list of all col indexes, that can be shared across all column groups if use full, can be set to null.
  `k` - The parallelization degree allowed internally in this operation.
Returns:
  The new Column Group or null that is the result of the matrix multiplication.

### replace

public AColGroup replace(double pattern, double replace)
Description copied from class: `AColGroup`
Make a copy of the column group values, and replace all values that match pattern with replacement value.

Specified by:
  `replace` in class `AColGroup`
Parameters:
  `pattern` - The value to look for
  `replace` - The value to replace the other value with
Returns:
  A new Column Group, reusing the index structure but with new values.

### getMin

public final double getMin()
Description copied from class: `AColGroup`
Short hand method for getting minimum value contained in this column group.

Overrides:
  `getMin` in class `AColGroupCompressed`
Returns:
  The minimum value contained in this ColumnGroup

### getMax

public final double getMax()
Description copied from class: `AColGroup`
Short hand method for getting maximum value contained in this column group.

Overrides:
  `getMax` in class `AColGroupCompressed`
Returns:
  The maximum value contained in this ColumnGroup

### computeColSums

public void computeColSums(double[] c, int nRows)
Description copied from class: `AColGroup`
Compute the column sum

Specified by:
  `computeColSums` in class `AColGroup`
Parameters:
  `c` - The array to add the column sum to.
  `nRows` - The number of rows in the column group.

### centralMoment

public CmCovObject centralMoment(CMOperator op, int nRows)
Description copied from class: `AColGroup`
Central Moment instruction executed on a column group.

Specified by:
  `centralMoment` in class `AColGroup`
Parameters:
  `op` - The Operator to use.
  `nRows` - The number of rows contained in the ColumnGroup.
Returns:
  A Central Moment object.

### rexpandCols

public AColGroup rexpandCols(int max, boolean ignore, boolean cast, int nRows)
Description copied from class: `AColGroup`
Expand the column group to multiple columns. (one hot encode the column group)

Specified by:
  `rexpandCols` in class `AColGroup`
Parameters:
  `max` - The number of columns to expand to and cutoff values at.
  `ignore` - If zero and negative values should be ignored.
  `cast` - If the double values contained should be cast to whole numbers.
  `nRows` - The number of rows in the column group.
Returns:
  A new column group containing max number of columns.

### getCost

public double getCost(ComputationCostEstimator e, int nRows)
Description copied from class: `AColGroup`
Get the computation cost associated with this column group.

Specified by:
  `getCost` in class `AColGroup`
Parameters:
  `e` - The computation cost estimator
  `nRows` - the number of rows in the column group
Returns:
  The cost of this column group

### isEmpty

public boolean isEmpty()
Description copied from class: `AColGroup`
Get if the group is only containing zero

Overrides:
  `isEmpty` in class `AColGroupCompressed`
Returns:
  true if empty

### read

public static ColGroupEmpty read(DataInput in) throws IOException

Throws:
  `IOException`

### sliceRows

public AColGroup sliceRows(int rl, int ru)
Description copied from class: `AColGroup`
Slice range of rows out of the column group and return a new column group only containing the row segment. Note that this slice should maintain pointers back to the original dictionaries and only modify index structures.

Specified by:
  `sliceRows` in class `AColGroup`
Parameters:
  `rl` - The row to start at
  `ru` - The row to end at (not included)
Returns:
  A new column group containing the specified row range.

### copyAndSet

public AColGroup copyAndSet(IColIndex colIndexes)
Description copied from class: `AColGroup`
Copy the content of the column group with pointers to the previous content but with new column given Note this method does not verify if the colIndexes specified are valid and correct dimensions for the underlying column groups.

Specified by:
  `copyAndSet` in class `AColGroup`
Parameters:
  `colIndexes` - the new indexes to use in the copy
Returns:
  a new object with pointers to underlying data.

### append

public AColGroup append(AColGroup g)
Description copied from class: `AColGroup`
Append the other column group to this column group. This method tries to combine them to return a new column group containing both. In some cases it is possible in reasonable time, in others it is not. The result is first this column group followed by the other column group in higher row values. If it is not possible or very inefficient null is returned.

Specified by:
  `append` in class `AColGroup`
Parameters:
  `g` - The other column group
Returns:
  A combined column group or null

### appendNInternal

public AColGroup appendNInternal(AColGroup[] g, int blen, int rlen)

### getCompressionScheme

public ICLAScheme getCompressionScheme()
Description copied from class: `AColGroup`
Get the compression scheme for this column group to enable compression of other data.

Specified by:
  `getCompressionScheme` in class `AColGroup`
Returns:
  The compression scheme of this column group

### recompress

public AColGroup recompress()
Description copied from class: `AColGroup`
Recompress this column group into a new column group.

Specified by:
  `recompress` in class `AColGroup`
Returns:
  A new or the same column group depending on optimization goal.

### getCompressionInfo

public CompressedSizeInfoColGroup getCompressionInfo(int nRow)
Description copied from class: `AColGroup`
Get the compression info for this column group.

Specified by:
  `getCompressionInfo` in class `AColGroup`
Parameters:
  `nRow` - The number of rows in this column group.
Returns:
  The compression info for this group.

### getEncoding

public IEncode getEncoding()
Description copied from class: `AColGroup`
Get encoding of this column group.

Overrides:
  `getEncoding` in class `AColGroup`
Returns:
  The encoding of the index structure.

### getDictionary

public ADictionary getDictionary()

Specified by:
  `getDictionary` in interface `IContainADictionary`

### getDefaultTuple

public double[] getDefaultTuple()

Specified by:
  `getDefaultTuple` in interface `IContainDefaultTuple`

### sameIndexStructure

public boolean sameIndexStructure(AColGroupCompressed that)

Specified by:
  `sameIndexStructure` in class `AColGroupCompressed`

### getOffsets

public AOffset getOffsets()

Specified by:
  `getOffsets` in interface `AOffsetsGroup`

### getMapToData

public AMapToData getMapToData()

Specified by:
  `getMapToData` in interface `IMapToDataGroup`

### reduceCols

public AColGroup reduceCols()
Description copied from class: `AColGroup`
Perform row sum on the internal dictionaries, and return the same index structure. This method returns null on empty column groups. Note this method does not guarantee correct behavior if the given group is AMorphingGroup, instead it should be morphed to a valid columngroup via extractCommon first.

Specified by:
  `reduceCols` in class `AColGroup`
Returns:
  The reduced colgroup.

### getSparsity

public double getSparsity()
Description copied from class: `AColGroup`
Get an approximate sparsity of this column group

Specified by:
  `getSparsity` in class `AColGroup`
Returns:
  the approximate sparsity of this columngroup

### combineWithSameIndex

public AColGroup combineWithSameIndex(int nRow, int nCol, AColGroup right)
Description copied from class: `AColGroup`
C bind the given column group to this.

Overrides:
  `combineWithSameIndex` in class `AColGroup`
Parameters:
  `nRow` - The number of rows contained in the right and this column group.
  `nCol` - The number of columns in this.
  `right` - The column group to c-bind.
Returns:
  a new combined column groups.

### splitReshape

public AColGroup[] splitReshape(int multiplier, int nRow, int nColOrg)
Description copied from class: `AColGroup`
This method returns a list of column groups that are naive splits of this column group as if it is reshaped. This means the column groups rows are split into x number of other column groups where x is the multiplier. The indexes are assigned round robbin to each of the output groups, meaning the first index is assigned. If for instance the 4. column group is split by a 2 multiplier and there was 5 columns in total originally. The output becomes 2 column groups at column index 4 and one at 9. If possible the split column groups should reuse pointers back to the original dictionaries!

Specified by:
  `splitReshape` in class `AColGroup`
Parameters:
  `multiplier` - The number of column groups to split into
  `nRow` - The number of rows in this column group in case the underlying column group does not know
  `nColOrg` - The number of overall columns in the host CompressedMatrixBlock.
Returns:
  a list of split column groups

### combineWithSameIndex

public AColGroup combineWithSameIndex(int nRow, int nCol, List<AColGroup> right)
Description copied from class: `AColGroup`
C bind the list of column groups with this column group. the list of elements provided in the index of each list is guaranteed to have the same index structures

Overrides:
  `combineWithSameIndex` in class `AColGroup`
Parameters:
  `nRow` - The number of rows contained in all right and this column group.
  `nCol` - The number of columns to shift the right hand side column groups over when combining, this should only effect the column indexes
  `right` - The right hand side column groups to combine. NOTE only the index offset of the second nested list should be used. The reason for providing this nested list is to avoid redundant allocations in calling methods.
Returns:
  A combined compressed column group of the same type as this!.

### removeEmptyRows

public AColGroup removeEmptyRows(boolean[] selectV, int rOut)
Description copied from class: `AColGroup`
Return a new column group containing only the selected rows in the given boolean vector. Whenever possible only modify the index structure, not the dictionary of the column groups.

Specified by:
  `removeEmptyRows` in class `AColGroup`
Parameters:
  `selectV` - The selection vector
  `rOut` - The number of rows in the output
Returns:
  The new column group

### sort

public AColGroup sort()
Description copied from class: `AColGroup`
Sort the values of the column group according to double comparison operations and return as another compressed group. This sorting assumes that the column group is sorted independently of everything else.

Specified by:
  `sort` in class `AColGroup`
Returns:
  The sorted group